#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

struct Node
{
   char Key;  
   Node* Left;
   Node* Right;

};

class Tree
{
  private:
	 Node* Root; //   .
	 FILE *fp;
  public:
	 Tree () { Root = NULL; fp = fopen ("DATE.DAT","w+"); };
	 ~Tree () { fclose(fp);}
	 void PrintTree (Node*, int);
	 void Search (char, Node**);
	 void Kill_Tree (Node**);
	 void Save_Tree (Node*);
	 void Load_Tree (Node **);
	 Node* GetTree() {return Root;};
	 Node** GetTree1() {return &Root;};
	 FILE* GetFile() {return fp;};
};

// ------------    ----------

void Tree::PrintTree (Node* W, int l)
{
  int i;

  if  (W!=NULL)
  {
	 PrintTree (W->Right,l+1);
	 for (i=1;i<=l;i++) cout << "   ";
	 cout << W->Key << endl;
	 PrintTree (W->Left,l+1);
  }
}

void Tree::Search (char X, Node** p)
{
  if (*p == NULL)
  {
    *p = new (Node); 
    (**p).Key = X;
    (**p).Left = (**p).Right = NULL;
  }
  else  
	if  (X<(**p).Key)  Search (X,&((**p).Left));
	else  if  (X>(**p).Key) Search (X,&((**p).Right));
}

void Tree::Kill_Tree (Node** Tree)
// ,  p p  .
{
  if ((*Tree)!=NULL)
  {
	 Kill_Tree (&((**Tree).Left) );
	 Kill_Tree (&((**Tree).Right));
	 delete (*Tree);
  }
}

void Tree::Save_Tree (Node* Tree)
//  p           p  .
//  p  p :
// a) p   p     
//     p, p   p:
//       = 1   p  p ;
//    p    = 1   p    ;
// b)    p  Key  p.
// ,     p    .
{
	unsigned char Kod;

	if (Tree!=NULL)
	{
		Kod = 0;
		if (Tree->Right!=NULL)  Kod = 1;
		if (Tree->Left!=NULL)  Kod = Kod | 2;
		fprintf (fp,"%c %c\n",Kod,Tree->Key);
		Save_Tree (Tree->Left );
		Save_Tree (Tree->Right);
	}
}

void Tree::Load_Tree (Node ** Tree)
//             p p  .
//  p  p :
//   a)      ( p)
//   b)   p  p  Key 
//      p.   .
//     )     = 3
//        ----     p   .
//                     p    p 
//                  Left.    Left  
//                  Right.
//                 = 1
//          -----  ----    p   p .
//                      --   .
//                       p   = 1
//                   -----  ----    p    .
//                               --   .
//                              p p
//                             -----
//    ,     p       .
{
	unsigned char Kodint; //   p.
	char  Soder;          //   p (p p).

	fscanf (fp, "%c %c\n", &Kodint, &Soder);
	(*Tree) = new (Node);
	(**Tree).Key = Soder;
	(**Tree).Left = (**Tree).Right = NULL;
	if  (Kodint==3)
	{
		Load_Tree (&((**Tree).Left) );
		Load_Tree (&((**Tree).Right));
	}
	else
	 if  ((Kodint & 1)!=0)  Load_Tree (&((**Tree).Right));
	 else
	  if ( (Kodint & 2)!=0 )  Load_Tree (&((**Tree).Left) );
}

void main()
{
  Tree A;
  char Symbol; //   p p p.
  // pp p      p.
  cout << "  .\n";
  cout << "    \"#\"\n";
  cin >> Symbol;
  while (Symbol!='#')
  {
    A.Search (Symbol,A.GetTree1());
    cin >> Symbol; 
  }
  cout << endl;
  if  (A.GetTree() == NULL)  //  p , ...
	 {  cout << "p !\n"; exit; }
  A.PrintTree (A.GetTree(),0);
  //  p       .
  A.Save_Tree (A.GetTree());
  rewind(A.GetFile());
  cout << "p p     \"DATE.DAT\"...\n";
  cout << "p   !\n";
  A.Kill_Tree (A.GetTree1());
  cout << " ------------------------------------------------ \n";
  //  p     ,  .
  cout << " p  ...\n";
  A.Load_Tree (A.GetTree1());
  A.PrintTree (A.GetTree(),0);
  cout << "p !\n";
}
